<?php
/*
* $Id: OptImages.php
* $Loc: /includes/hooks/admin/products_attributes/
*
* Name: OptionsImages
* Version: 2.6
* Release Date: 2024-07-19
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

class hook_admin_products_attributes_OptImages {

  public $version = '2.5';

    function listen_addProductOptionValuesAction() {

      $option_value_image = new upload('option_value_image');
      $option_value_image->set_destination(DIR_FS_CATALOG . 'images/options/' );

      if ($option_value_image->parse() && $option_value_image->save()) {
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_options_values
  SET products_options_values_image = '%s'
  WHERE products_options_values_id = %s
EOSQL
        , $GLOBALS['db']->escape($option_value_image->filename), $GLOBALS['value_id']));

      }
    }

    function listen_updateValueAction() {

      // Start options values images
      $option_value_image = new upload('option_value_image');
      $option_value_image->set_destination(DIR_FS_CATALOG . 'images/options/' );

      if ($option_value_image->parse() && $option_value_image->save()) {
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_options_values
  SET products_options_values_image = '%s'
  WHERE products_options_values_id = %s
EOSQL
        , $GLOBALS['db']->escape($option_value_image->filename), $GLOBALS['value_id']));

      //add remove image function
      } elseif( (isset($_POST['unlink_value_image']) && $_POST['unlink_value_image'] == 'yes') || (isset($_POST['delete_value_image']) && $_POST['delete_value_image'] == 'yes')){
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_options_values
  SET products_options_values_image = ''
  WHERE products_options_values_id = %s
EOSQL
        , $GLOBALS['value_id']));

      }
      //add delete image function
      if (isset($_POST['delete_value_image']) && $_POST['delete_value_image'] == 'yes') {
        unlink(DIR_FS_CATALOG . 'images/options/' . $_POST['option_values_previous_image']);
      }
      // End options values images

    }

    function listen_addProductAttributesAction() {

      // Start attibutes images
      $option_image = new upload('option_image');
      $option_image->set_destination(DIR_FS_CATALOG . 'images/options/');

      if ($option_image->parse() && $option_image->save()) {
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_attributes
  SET option_image = '%s'
  WHERE products_attributes_id = %s
EOSQL
        , $GLOBALS['db']->escape($option_image->filename), $GLOBALS['products_attributes_id']));

      }
      // End attributes images

    }

    function listen_updateProductAttributeAction() {

      // Start attibutes images
      $option_image = new upload('option_image');
      $option_image->set_destination(DIR_FS_CATALOG . 'images/options/');

      if ($option_image->parse() && $option_image->save()) {
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_attributes
  SET option_image = '%s'
  WHERE products_attributes_id = %s
EOSQL
        , $GLOBALS['db']->escape($option_image->filename), $GLOBALS['attribute_id']));

      //add remove image function
      } elseif( (isset($_POST['unlink_image']) && $_POST['unlink_image'] == 'yes') || (isset($_POST['delete_image']) && $_POST['delete_image'] == 'yes')){
        $GLOBALS['db']->query(sprintf(<<<'EOSQL'
UPDATE products_attributes
  SET option_image = ''
  WHERE products_attributes_id = %s
EOSQL
        , $GLOBALS['attribute_id']));

      }
      //add delete image function
      if (isset($_POST['delete_image']) && $_POST['delete_image'] == 'yes') {
        unlink(DIR_FS_CATALOG . 'images/options/' . $_POST['option_previous_image']);
      }
      // End attributes images

    }

  function listen_injectSiteEnd() {

    $output = null;

    if ( Request::get_page() == 'products_attributes.php' ) {
      global $action, $values_query, $attributes_query;

      $attributes_values = $attributes_query->data_seek(0);

      $output = PHP_EOL . <<<EOD
<script>
$(function() {
EOD;

      $header_title_images = TABLE_HEADING_OPT_IMAGE;

      $output .= PHP_EOL . <<<EOD
$('table:eq(0) thead tr th:nth-child(5)').after('<th>{$header_title_images}</th>');
$('form[name="attributes"]').attr('enctype','multipart/form-data');
EOD;

      $row_id = 0;
      while ( $attributes_values = $attributes_query->fetch_assoc() ) {

        $values_image = $attributes_values['option_image'];

        if (($action == 'update_attribute') && ($_GET['attribute_id'] == $attributes_values['products_attributes_id'])) {
          $values_image_input = ' <td class="w-25">';
          $values_image_input .= '  <div class="input-group mb-1">';
          $values_image_input .= '    <div class="custom-file mb-2">';
          $values_image_input .=        new Input('option_image', ['id' => 'optImg', 'type' => 'file', 'class' => 'custom-file-input']) . new Input('option_previous_image', ['value' => $values_image], 'hidden') .
                                        '<label class="custom-file-label" for="optImg">' .  (!empty($values_image)? $values_image : TABLE_HEADING_OPT_IMAGE) .  '</label>';
          $values_image_input .= '    </div>';
          $values_image_input .= '    <div class="input-group">';
          $values_image_input .= '      <div class="form-group row align-items-center mb-0">';
          $values_image_input .= '        <div class="col-form-label col-sm-1 text-left text-sm-right">&nbsp;</div>';
          $values_image_input .= '        <div class="col-sm-5 pl-5 custom-control custom-switch">';
          $values_image_input .=            new Tickable('unlink_image', ['value' => 'yes', 'class' => 'custom-control-input', 'id' => 'oRemoveImage', 'checkbox']);
          $values_image_input .= '          <label for="oRemoveImage" class="custom-control-label text-muted"><small>' . REMOVE_OPT_IMAGE . '</small></label>';
          $values_image_input .= '        </div>';
          $values_image_input .= '        <div class="col-sm-5 pl-5 custom-control custom-switch">';
          $values_image_input .=            new Tickable('delete_image', ['value' => 'yes', 'class' => 'custom-control-input', 'id' => 'oDeleteImage', 'checkbox']);
          $values_image_input .= '          <label for="oDeleteImage" class="custom-control-label text-muted"><small>' . DELETE_OPT_IMAGE . '</small></label>';
          $values_image_input .= '        </div>';
          $values_image_input .= '      </div>';
          $values_image_input .= '    </div>';
          $values_image_input .= '  </td>';

          $output .= PHP_EOL . <<<EOD
$('form[name="attributes"]').attr('enctype','multipart/form-data');
$('table:eq(0) tbody tr td input[name="price_prefix"]').closest('td').after('{$values_image_input}');
EOD;

        } else {
          if (!empty($values_image)) {
            $values_image_output = '<td class="smallText">&nbsp;' .  new Image(HTTP_CATALOG_SERVER . DIR_WS_CATALOG . 'images/options/' . $values_image, ['title' => $values_image, 'width' =>'40px', 'height' => '40px']) . '&nbsp;' . $values_image . '&nbsp;</td>';
          } else {
            $values_image_output = '<td class="smallText">&nbsp;</td>';
          }
          $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr:eq({$row_id}) td:nth-child(5)').after('{$values_image_output}');
EOD;

        }
        $row_id ++;
      }

      if ($action != 'update_attribute') {

        $values_image_input = ' <td class="w-25">';
        $values_image_input .= '  <div class="input-group mb-1">';
        $values_image_input .= '    <div class="custom-file mb-2">';
        $values_image_input .=        new Input('option_image', ['id' => 'opImg', 'type' => 'file', 'class' => 'custom-file-input']) .
                                      '<label class="custom-file-label" for="opImg">' .  TABLE_HEADING_OPT_IMAGE .  '</label>';
        $values_image_input .= '    </div>';
        $values_image_input .= '  </div>';
        $values_image_input .= '</td>';

        $output .= PHP_EOL . <<<EOD
$('table:eq(0) tbody tr td input[name="price_prefix"]').closest('td').after('{$values_image_input}');
EOD;

      }

      $output .= PHP_EOL . <<<EOD
$('table:eq(2) thead tr th:nth-child(3)').after('<th>{$header_title_images}</th>');
EOD;

      $values_values = $values_query->data_seek(0);
      $row_id = 0;
      while ($values_values = $values_query->fetch_assoc()) {

        $values_image = $values_values['products_options_values_image'];

        if (($action == 'update_option_value') && ($_GET['value_id'] == $values_values['products_options_values_id'])) {

          $values_image_input = ' <div class="col-sm-3">';
          $values_image_input .= '  <div class="input-group mb-1">';
          $values_image_input .= '    <div class="custom-file mb-2">';
          $values_image_input .=        new Input('option_value_image', ['id' => 'oImg', 'type' => 'file', 'class' => 'custom-file-input']) . new Input('option_values_previous_image', ['value' => $values_image], 'hidden') .
                                        '<label class="custom-file-label" for="oImg">' .  (!empty($values_image)? $values_image : TABLE_HEADING_OPT_IMAGE) .  '</label>';
          $values_image_input .= '    </div>';
          $values_image_input .= '    <div class="input-group">';
          $values_image_input .= '      <div class="form-group row align-items-center mb-0">';
          $values_image_input .= '        <div class="col-form-label col-sm-1 text-left text-sm-right">&nbsp;</div>';
          $values_image_input .= '        <div class="col-sm-5 pl-5 custom-control custom-switch">';
          $values_image_input .=            new Tickable('unlink_value_image', ['value' => 'yes', 'class' => 'custom-control-input', 'id' => 'avRemoveImage', 'checkbox']);
          $values_image_input .= '          <label for="avRemoveImage" class="custom-control-label text-muted"><small>' . REMOVE_OPT_IMAGE . '</small></label>';
          $values_image_input .= '        </div>';
          $values_image_input .= '        <div class="col-sm-5 pl-5 custom-control custom-switch">';
          $values_image_input .=            new Tickable('delete_value_image', ['value' => 'yes', 'class' => 'custom-control-input', 'id' => 'avDeleteImage', 'checkbox']);
          $values_image_input .= '          <label for="avDeleteImage" class="custom-control-label text-muted"><small>' . DELETE_OPT_IMAGE . '</small></label>';
          $values_image_input .= '        </div>';
          $values_image_input .= '      </div>';
          $values_image_input .= '    </div>';
          $values_image_input .= '  </div>';

          $output .= PHP_EOL . <<<EOD
$('form[name="values"]').attr('enctype','multipart/form-data');
$('table:eq(2) tbody tr:eq({$row_id}) td div:nth-child(4)').before('{$values_image_input}');
$('table:eq(2) tbody tr:eq({$row_id}) td div .col-4').toggleClass('col-4 col-1');
$('table:eq(2) tbody tr:eq({$row_id}) td[colspan=4]').attr('colspan', '5');
EOD;

        } else {
          if (!empty($values_image)) {
            $values_image_output = '<td class="smallText">&nbsp;' .  new Image(HTTP_CATALOG_SERVER . DIR_WS_CATALOG . 'images/options/' . $values_image, ['title' => $values_image, 'width' =>'40px', 'height' => '40px']) . '&nbsp;' . $values_image . '&nbsp;</td>';
          } else {
            $values_image_output = '<td class="smallText">&nbsp;</td>';
          }
          $output .= PHP_EOL . <<<EOD
$('table:eq(2) tbody tr:eq({$row_id}) td:nth-child(3)').after('{$values_image_output}');
EOD;

        }
        $row_id ++;
      }

      if ($action != 'update_option_value') {
        $values_image_input = ' <div class="col-sm-3">';
        $values_image_input .= '  <div class="input-group mb-1">';
        $values_image_input .= '    <div class="custom-file mb-2">';
        $values_image_input .=        new Input('option_value_image', ['id' => 'ovImg', 'type' => 'file', 'class' => 'custom-file-input']) .
                                      '<label class="custom-file-label" for="ovImg">' .  TABLE_HEADING_OPT_IMAGE .  '</label>';
        $values_image_input .= '    </div>';
        $values_image_input .= '  </div>';
        $values_image_input .= '</div>';

        $output .= PHP_EOL . <<<EOD
$('form[name="values"]').attr('enctype','multipart/form-data');
$('table:eq(2) tbody tr:last td div:last()').before('{$values_image_input}');
$('table:eq(2) tbody tr td div .col-4').toggleClass('col-4 col-1');
$('table:eq(2) tbody tr td[colspan=4]').attr('colspan', '5');
EOD;

      }

      $output .= PHP_EOL . <<<EOD
});
</script>
EOD;

      return $output;
    }
  }

}
